// source: v1/dictionary_md/product_package.proto
/**
 * @fileoverview
 * @enhanceable
 * @suppress {messageConventions} JS Compiler reports an error if a variable or
 *     field starts with 'MSG_' and isn't a translatable message.
 * @public
 */
// GENERATED CODE -- DO NOT EDIT!

var jspb = require('google-protobuf');
var goog = jspb;
var global = Function('return this')();

var google_protobuf_wrappers_pb = require('google-protobuf/google/protobuf/wrappers_pb.js');
goog.object.extend(proto, google_protobuf_wrappers_pb);
var google_protobuf_timestamp_pb = require('google-protobuf/google/protobuf/timestamp_pb.js');
goog.object.extend(proto, google_protobuf_timestamp_pb);
var v1_dictionary_common_dictionary_common_pb = require('../../v1/dictionary_common/dictionary_common_pb.js');
goog.object.extend(proto, v1_dictionary_common_dictionary_common_pb);
var v1_dictionary_common_enum_product_pb = require('../../v1/dictionary_common/enum_product_pb.js');
goog.object.extend(proto, v1_dictionary_common_enum_product_pb);
goog.exportSymbol('proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest', null, global);
goog.exportSymbol('proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse', null, global);
goog.exportSymbol('proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest', null, global);
goog.exportSymbol('proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse', null, global);
goog.exportSymbol('proto.fcp.dictionary.v1.dictionary_md.ProductPackage', null, global);
goog.exportSymbol('proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter', null, global);
goog.exportSymbol('proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest', null, global);
goog.exportSymbol('proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse', null, global);
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.fcp.dictionary.v1.dictionary_md.ProductPackage, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.fcp.dictionary.v1.dictionary_md.ProductPackage.displayName = 'proto.fcp.dictionary.v1.dictionary_md.ProductPackage';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.displayName = 'proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest.displayName = 'proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse.displayName = 'proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.repeatedFields_, null);
};
goog.inherits(proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.displayName = 'proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.repeatedFields_, null);
};
goog.inherits(proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.displayName = 'proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest.displayName = 'proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse.displayName = 'proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse';
}



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.toObject = function(opt_includeInstance) {
  return proto.fcp.dictionary.v1.dictionary_md.ProductPackage.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.toObject = function(includeInstance, msg) {
  var f, obj = {
    id: jspb.Message.getFieldWithDefault(msg, 1, 0),
    productId: jspb.Message.getFieldWithDefault(msg, 2, 0),
    productName: jspb.Message.getFieldWithDefault(msg, 3, ""),
    amount: jspb.Message.getFieldWithDefault(msg, 4, 0),
    quantityTypeId: jspb.Message.getFieldWithDefault(msg, 5, 0),
    quantityTypeName: jspb.Message.getFieldWithDefault(msg, 6, ""),
    quantityTypeShortName: jspb.Message.getFieldWithDefault(msg, 10, ""),
    type: jspb.Message.getFieldWithDefault(msg, 11, 0),
    brandId: jspb.Message.getFieldWithDefault(msg, 12, 0),
    brandName: jspb.Message.getFieldWithDefault(msg, 13, ""),
    length: jspb.Message.getFieldWithDefault(msg, 7, 0),
    width: jspb.Message.getFieldWithDefault(msg, 8, 0),
    height: jspb.Message.getFieldWithDefault(msg, 9, 0),
    audit: (f = msg.getAudit()) && v1_dictionary_common_dictionary_common_pb.Audit.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.fcp.dictionary.v1.dictionary_md.ProductPackage;
  return proto.fcp.dictionary.v1.dictionary_md.ProductPackage.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {number} */ (reader.readInt64());
      msg.setId(value);
      break;
    case 2:
      var value = /** @type {number} */ (reader.readInt64());
      msg.setProductId(value);
      break;
    case 3:
      var value = /** @type {string} */ (reader.readString());
      msg.setProductName(value);
      break;
    case 4:
      var value = /** @type {number} */ (reader.readInt64());
      msg.setAmount(value);
      break;
    case 5:
      var value = /** @type {number} */ (reader.readInt64());
      msg.setQuantityTypeId(value);
      break;
    case 6:
      var value = /** @type {string} */ (reader.readString());
      msg.setQuantityTypeName(value);
      break;
    case 10:
      var value = /** @type {string} */ (reader.readString());
      msg.setQuantityTypeShortName(value);
      break;
    case 11:
      var value = /** @type {!proto.fcp.dictionary.v1.dictionary_common.ProductType} */ (reader.readEnum());
      msg.setType(value);
      break;
    case 12:
      var value = /** @type {number} */ (reader.readInt64());
      msg.setBrandId(value);
      break;
    case 13:
      var value = /** @type {string} */ (reader.readString());
      msg.setBrandName(value);
      break;
    case 7:
      var value = /** @type {number} */ (reader.readInt64());
      msg.setLength(value);
      break;
    case 8:
      var value = /** @type {number} */ (reader.readInt64());
      msg.setWidth(value);
      break;
    case 9:
      var value = /** @type {number} */ (reader.readInt64());
      msg.setHeight(value);
      break;
    case 21:
      var value = new v1_dictionary_common_dictionary_common_pb.Audit;
      reader.readMessage(value,v1_dictionary_common_dictionary_common_pb.Audit.deserializeBinaryFromReader);
      msg.setAudit(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.fcp.dictionary.v1.dictionary_md.ProductPackage.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getId();
  if (f !== 0) {
    writer.writeInt64(
      1,
      f
    );
  }
  f = message.getProductId();
  if (f !== 0) {
    writer.writeInt64(
      2,
      f
    );
  }
  f = message.getProductName();
  if (f.length > 0) {
    writer.writeString(
      3,
      f
    );
  }
  f = message.getAmount();
  if (f !== 0) {
    writer.writeInt64(
      4,
      f
    );
  }
  f = message.getQuantityTypeId();
  if (f !== 0) {
    writer.writeInt64(
      5,
      f
    );
  }
  f = message.getQuantityTypeName();
  if (f.length > 0) {
    writer.writeString(
      6,
      f
    );
  }
  f = message.getQuantityTypeShortName();
  if (f.length > 0) {
    writer.writeString(
      10,
      f
    );
  }
  f = message.getType();
  if (f !== 0.0) {
    writer.writeEnum(
      11,
      f
    );
  }
  f = message.getBrandId();
  if (f !== 0) {
    writer.writeInt64(
      12,
      f
    );
  }
  f = message.getBrandName();
  if (f.length > 0) {
    writer.writeString(
      13,
      f
    );
  }
  f = message.getLength();
  if (f !== 0) {
    writer.writeInt64(
      7,
      f
    );
  }
  f = message.getWidth();
  if (f !== 0) {
    writer.writeInt64(
      8,
      f
    );
  }
  f = message.getHeight();
  if (f !== 0) {
    writer.writeInt64(
      9,
      f
    );
  }
  f = message.getAudit();
  if (f != null) {
    writer.writeMessage(
      21,
      f,
      v1_dictionary_common_dictionary_common_pb.Audit.serializeBinaryToWriter
    );
  }
};


/**
 * optional int64 id = 1;
 * @return {number}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.getId = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 1, 0));
};


/**
 * @param {number} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.setId = function(value) {
  return jspb.Message.setProto3IntField(this, 1, value);
};


/**
 * optional int64 product_id = 2;
 * @return {number}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.getProductId = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 2, 0));
};


/**
 * @param {number} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.setProductId = function(value) {
  return jspb.Message.setProto3IntField(this, 2, value);
};


/**
 * optional string product_name = 3;
 * @return {string}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.getProductName = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 3, ""));
};


/**
 * @param {string} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.setProductName = function(value) {
  return jspb.Message.setProto3StringField(this, 3, value);
};


/**
 * optional int64 amount = 4;
 * @return {number}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.getAmount = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 4, 0));
};


/**
 * @param {number} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.setAmount = function(value) {
  return jspb.Message.setProto3IntField(this, 4, value);
};


/**
 * optional int64 quantity_type_id = 5;
 * @return {number}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.getQuantityTypeId = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 5, 0));
};


/**
 * @param {number} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.setQuantityTypeId = function(value) {
  return jspb.Message.setProto3IntField(this, 5, value);
};


/**
 * optional string quantity_type_name = 6;
 * @return {string}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.getQuantityTypeName = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 6, ""));
};


/**
 * @param {string} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.setQuantityTypeName = function(value) {
  return jspb.Message.setProto3StringField(this, 6, value);
};


/**
 * optional string quantity_type_short_name = 10;
 * @return {string}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.getQuantityTypeShortName = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 10, ""));
};


/**
 * @param {string} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.setQuantityTypeShortName = function(value) {
  return jspb.Message.setProto3StringField(this, 10, value);
};


/**
 * optional fcp.dictionary.v1.dictionary_common.ProductType type = 11;
 * @return {!proto.fcp.dictionary.v1.dictionary_common.ProductType}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.getType = function() {
  return /** @type {!proto.fcp.dictionary.v1.dictionary_common.ProductType} */ (jspb.Message.getFieldWithDefault(this, 11, 0));
};


/**
 * @param {!proto.fcp.dictionary.v1.dictionary_common.ProductType} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.setType = function(value) {
  return jspb.Message.setProto3EnumField(this, 11, value);
};


/**
 * optional int64 brand_id = 12;
 * @return {number}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.getBrandId = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 12, 0));
};


/**
 * @param {number} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.setBrandId = function(value) {
  return jspb.Message.setProto3IntField(this, 12, value);
};


/**
 * optional string brand_name = 13;
 * @return {string}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.getBrandName = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 13, ""));
};


/**
 * @param {string} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.setBrandName = function(value) {
  return jspb.Message.setProto3StringField(this, 13, value);
};


/**
 * optional int64 length = 7;
 * @return {number}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.getLength = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 7, 0));
};


/**
 * @param {number} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.setLength = function(value) {
  return jspb.Message.setProto3IntField(this, 7, value);
};


/**
 * optional int64 width = 8;
 * @return {number}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.getWidth = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 8, 0));
};


/**
 * @param {number} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.setWidth = function(value) {
  return jspb.Message.setProto3IntField(this, 8, value);
};


/**
 * optional int64 height = 9;
 * @return {number}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.getHeight = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 9, 0));
};


/**
 * @param {number} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.setHeight = function(value) {
  return jspb.Message.setProto3IntField(this, 9, value);
};


/**
 * optional fcp.dictionary.v1.dictionary_common.Audit audit = 21;
 * @return {?proto.fcp.dictionary.v1.dictionary_common.Audit}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.getAudit = function() {
  return /** @type{?proto.fcp.dictionary.v1.dictionary_common.Audit} */ (
    jspb.Message.getWrapperField(this, v1_dictionary_common_dictionary_common_pb.Audit, 21));
};


/**
 * @param {?proto.fcp.dictionary.v1.dictionary_common.Audit|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.setAudit = function(value) {
  return jspb.Message.setWrapperField(this, 21, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.clearAudit = function() {
  return this.setAudit(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackage.prototype.hasAudit = function() {
  return jspb.Message.getField(this, 21) != null;
};





if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.toObject = function(opt_includeInstance) {
  return proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.toObject = function(includeInstance, msg) {
  var f, obj = {
    id: (f = msg.getId()) && google_protobuf_wrappers_pb.Int64Value.toObject(includeInstance, f),
    productId: (f = msg.getProductId()) && google_protobuf_wrappers_pb.Int64Value.toObject(includeInstance, f),
    productName: (f = msg.getProductName()) && google_protobuf_wrappers_pb.StringValue.toObject(includeInstance, f),
    quantityTypeId: (f = msg.getQuantityTypeId()) && google_protobuf_wrappers_pb.Int64Value.toObject(includeInstance, f),
    brandId: (f = msg.getBrandId()) && google_protobuf_wrappers_pb.Int64Value.toObject(includeInstance, f),
    brandName: (f = msg.getBrandName()) && google_protobuf_wrappers_pb.StringValue.toObject(includeInstance, f),
    productType: (f = msg.getProductType()) && v1_dictionary_common_enum_product_pb.ProductTypeValue.toObject(includeInstance, f),
    state: (f = msg.getState()) && v1_dictionary_common_dictionary_common_pb.StateValue.toObject(includeInstance, f),
    createdAt: (f = msg.getCreatedAt()) && v1_dictionary_common_dictionary_common_pb.TimeRange.toObject(includeInstance, f),
    createdBy: (f = msg.getCreatedBy()) && google_protobuf_wrappers_pb.StringValue.toObject(includeInstance, f),
    updatedAt: (f = msg.getUpdatedAt()) && v1_dictionary_common_dictionary_common_pb.TimeRange.toObject(includeInstance, f),
    updatedBy: (f = msg.getUpdatedBy()) && google_protobuf_wrappers_pb.StringValue.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter;
  return proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new google_protobuf_wrappers_pb.Int64Value;
      reader.readMessage(value,google_protobuf_wrappers_pb.Int64Value.deserializeBinaryFromReader);
      msg.setId(value);
      break;
    case 2:
      var value = new google_protobuf_wrappers_pb.Int64Value;
      reader.readMessage(value,google_protobuf_wrappers_pb.Int64Value.deserializeBinaryFromReader);
      msg.setProductId(value);
      break;
    case 5:
      var value = new google_protobuf_wrappers_pb.StringValue;
      reader.readMessage(value,google_protobuf_wrappers_pb.StringValue.deserializeBinaryFromReader);
      msg.setProductName(value);
      break;
    case 4:
      var value = new google_protobuf_wrappers_pb.Int64Value;
      reader.readMessage(value,google_protobuf_wrappers_pb.Int64Value.deserializeBinaryFromReader);
      msg.setQuantityTypeId(value);
      break;
    case 6:
      var value = new google_protobuf_wrappers_pb.Int64Value;
      reader.readMessage(value,google_protobuf_wrappers_pb.Int64Value.deserializeBinaryFromReader);
      msg.setBrandId(value);
      break;
    case 7:
      var value = new google_protobuf_wrappers_pb.StringValue;
      reader.readMessage(value,google_protobuf_wrappers_pb.StringValue.deserializeBinaryFromReader);
      msg.setBrandName(value);
      break;
    case 8:
      var value = new v1_dictionary_common_enum_product_pb.ProductTypeValue;
      reader.readMessage(value,v1_dictionary_common_enum_product_pb.ProductTypeValue.deserializeBinaryFromReader);
      msg.setProductType(value);
      break;
    case 21:
      var value = new v1_dictionary_common_dictionary_common_pb.StateValue;
      reader.readMessage(value,v1_dictionary_common_dictionary_common_pb.StateValue.deserializeBinaryFromReader);
      msg.setState(value);
      break;
    case 23:
      var value = new v1_dictionary_common_dictionary_common_pb.TimeRange;
      reader.readMessage(value,v1_dictionary_common_dictionary_common_pb.TimeRange.deserializeBinaryFromReader);
      msg.setCreatedAt(value);
      break;
    case 24:
      var value = new google_protobuf_wrappers_pb.StringValue;
      reader.readMessage(value,google_protobuf_wrappers_pb.StringValue.deserializeBinaryFromReader);
      msg.setCreatedBy(value);
      break;
    case 25:
      var value = new v1_dictionary_common_dictionary_common_pb.TimeRange;
      reader.readMessage(value,v1_dictionary_common_dictionary_common_pb.TimeRange.deserializeBinaryFromReader);
      msg.setUpdatedAt(value);
      break;
    case 26:
      var value = new google_protobuf_wrappers_pb.StringValue;
      reader.readMessage(value,google_protobuf_wrappers_pb.StringValue.deserializeBinaryFromReader);
      msg.setUpdatedBy(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getId();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      google_protobuf_wrappers_pb.Int64Value.serializeBinaryToWriter
    );
  }
  f = message.getProductId();
  if (f != null) {
    writer.writeMessage(
      2,
      f,
      google_protobuf_wrappers_pb.Int64Value.serializeBinaryToWriter
    );
  }
  f = message.getProductName();
  if (f != null) {
    writer.writeMessage(
      5,
      f,
      google_protobuf_wrappers_pb.StringValue.serializeBinaryToWriter
    );
  }
  f = message.getQuantityTypeId();
  if (f != null) {
    writer.writeMessage(
      4,
      f,
      google_protobuf_wrappers_pb.Int64Value.serializeBinaryToWriter
    );
  }
  f = message.getBrandId();
  if (f != null) {
    writer.writeMessage(
      6,
      f,
      google_protobuf_wrappers_pb.Int64Value.serializeBinaryToWriter
    );
  }
  f = message.getBrandName();
  if (f != null) {
    writer.writeMessage(
      7,
      f,
      google_protobuf_wrappers_pb.StringValue.serializeBinaryToWriter
    );
  }
  f = message.getProductType();
  if (f != null) {
    writer.writeMessage(
      8,
      f,
      v1_dictionary_common_enum_product_pb.ProductTypeValue.serializeBinaryToWriter
    );
  }
  f = message.getState();
  if (f != null) {
    writer.writeMessage(
      21,
      f,
      v1_dictionary_common_dictionary_common_pb.StateValue.serializeBinaryToWriter
    );
  }
  f = message.getCreatedAt();
  if (f != null) {
    writer.writeMessage(
      23,
      f,
      v1_dictionary_common_dictionary_common_pb.TimeRange.serializeBinaryToWriter
    );
  }
  f = message.getCreatedBy();
  if (f != null) {
    writer.writeMessage(
      24,
      f,
      google_protobuf_wrappers_pb.StringValue.serializeBinaryToWriter
    );
  }
  f = message.getUpdatedAt();
  if (f != null) {
    writer.writeMessage(
      25,
      f,
      v1_dictionary_common_dictionary_common_pb.TimeRange.serializeBinaryToWriter
    );
  }
  f = message.getUpdatedBy();
  if (f != null) {
    writer.writeMessage(
      26,
      f,
      google_protobuf_wrappers_pb.StringValue.serializeBinaryToWriter
    );
  }
};


/**
 * optional google.protobuf.Int64Value id = 1;
 * @return {?proto.google.protobuf.Int64Value}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.getId = function() {
  return /** @type{?proto.google.protobuf.Int64Value} */ (
    jspb.Message.getWrapperField(this, google_protobuf_wrappers_pb.Int64Value, 1));
};


/**
 * @param {?proto.google.protobuf.Int64Value|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.setId = function(value) {
  return jspb.Message.setWrapperField(this, 1, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.clearId = function() {
  return this.setId(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.hasId = function() {
  return jspb.Message.getField(this, 1) != null;
};


/**
 * optional google.protobuf.Int64Value product_id = 2;
 * @return {?proto.google.protobuf.Int64Value}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.getProductId = function() {
  return /** @type{?proto.google.protobuf.Int64Value} */ (
    jspb.Message.getWrapperField(this, google_protobuf_wrappers_pb.Int64Value, 2));
};


/**
 * @param {?proto.google.protobuf.Int64Value|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.setProductId = function(value) {
  return jspb.Message.setWrapperField(this, 2, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.clearProductId = function() {
  return this.setProductId(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.hasProductId = function() {
  return jspb.Message.getField(this, 2) != null;
};


/**
 * optional google.protobuf.StringValue product_name = 5;
 * @return {?proto.google.protobuf.StringValue}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.getProductName = function() {
  return /** @type{?proto.google.protobuf.StringValue} */ (
    jspb.Message.getWrapperField(this, google_protobuf_wrappers_pb.StringValue, 5));
};


/**
 * @param {?proto.google.protobuf.StringValue|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.setProductName = function(value) {
  return jspb.Message.setWrapperField(this, 5, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.clearProductName = function() {
  return this.setProductName(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.hasProductName = function() {
  return jspb.Message.getField(this, 5) != null;
};


/**
 * optional google.protobuf.Int64Value quantity_type_id = 4;
 * @return {?proto.google.protobuf.Int64Value}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.getQuantityTypeId = function() {
  return /** @type{?proto.google.protobuf.Int64Value} */ (
    jspb.Message.getWrapperField(this, google_protobuf_wrappers_pb.Int64Value, 4));
};


/**
 * @param {?proto.google.protobuf.Int64Value|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.setQuantityTypeId = function(value) {
  return jspb.Message.setWrapperField(this, 4, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.clearQuantityTypeId = function() {
  return this.setQuantityTypeId(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.hasQuantityTypeId = function() {
  return jspb.Message.getField(this, 4) != null;
};


/**
 * optional google.protobuf.Int64Value brand_id = 6;
 * @return {?proto.google.protobuf.Int64Value}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.getBrandId = function() {
  return /** @type{?proto.google.protobuf.Int64Value} */ (
    jspb.Message.getWrapperField(this, google_protobuf_wrappers_pb.Int64Value, 6));
};


/**
 * @param {?proto.google.protobuf.Int64Value|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.setBrandId = function(value) {
  return jspb.Message.setWrapperField(this, 6, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.clearBrandId = function() {
  return this.setBrandId(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.hasBrandId = function() {
  return jspb.Message.getField(this, 6) != null;
};


/**
 * optional google.protobuf.StringValue brand_name = 7;
 * @return {?proto.google.protobuf.StringValue}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.getBrandName = function() {
  return /** @type{?proto.google.protobuf.StringValue} */ (
    jspb.Message.getWrapperField(this, google_protobuf_wrappers_pb.StringValue, 7));
};


/**
 * @param {?proto.google.protobuf.StringValue|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.setBrandName = function(value) {
  return jspb.Message.setWrapperField(this, 7, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.clearBrandName = function() {
  return this.setBrandName(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.hasBrandName = function() {
  return jspb.Message.getField(this, 7) != null;
};


/**
 * optional fcp.dictionary.v1.dictionary_common.ProductTypeValue product_type = 8;
 * @return {?proto.fcp.dictionary.v1.dictionary_common.ProductTypeValue}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.getProductType = function() {
  return /** @type{?proto.fcp.dictionary.v1.dictionary_common.ProductTypeValue} */ (
    jspb.Message.getWrapperField(this, v1_dictionary_common_enum_product_pb.ProductTypeValue, 8));
};


/**
 * @param {?proto.fcp.dictionary.v1.dictionary_common.ProductTypeValue|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.setProductType = function(value) {
  return jspb.Message.setWrapperField(this, 8, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.clearProductType = function() {
  return this.setProductType(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.hasProductType = function() {
  return jspb.Message.getField(this, 8) != null;
};


/**
 * optional fcp.dictionary.v1.dictionary_common.StateValue state = 21;
 * @return {?proto.fcp.dictionary.v1.dictionary_common.StateValue}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.getState = function() {
  return /** @type{?proto.fcp.dictionary.v1.dictionary_common.StateValue} */ (
    jspb.Message.getWrapperField(this, v1_dictionary_common_dictionary_common_pb.StateValue, 21));
};


/**
 * @param {?proto.fcp.dictionary.v1.dictionary_common.StateValue|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.setState = function(value) {
  return jspb.Message.setWrapperField(this, 21, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.clearState = function() {
  return this.setState(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.hasState = function() {
  return jspb.Message.getField(this, 21) != null;
};


/**
 * optional fcp.dictionary.v1.dictionary_common.TimeRange created_at = 23;
 * @return {?proto.fcp.dictionary.v1.dictionary_common.TimeRange}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.getCreatedAt = function() {
  return /** @type{?proto.fcp.dictionary.v1.dictionary_common.TimeRange} */ (
    jspb.Message.getWrapperField(this, v1_dictionary_common_dictionary_common_pb.TimeRange, 23));
};


/**
 * @param {?proto.fcp.dictionary.v1.dictionary_common.TimeRange|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.setCreatedAt = function(value) {
  return jspb.Message.setWrapperField(this, 23, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.clearCreatedAt = function() {
  return this.setCreatedAt(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.hasCreatedAt = function() {
  return jspb.Message.getField(this, 23) != null;
};


/**
 * optional google.protobuf.StringValue created_by = 24;
 * @return {?proto.google.protobuf.StringValue}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.getCreatedBy = function() {
  return /** @type{?proto.google.protobuf.StringValue} */ (
    jspb.Message.getWrapperField(this, google_protobuf_wrappers_pb.StringValue, 24));
};


/**
 * @param {?proto.google.protobuf.StringValue|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.setCreatedBy = function(value) {
  return jspb.Message.setWrapperField(this, 24, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.clearCreatedBy = function() {
  return this.setCreatedBy(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.hasCreatedBy = function() {
  return jspb.Message.getField(this, 24) != null;
};


/**
 * optional fcp.dictionary.v1.dictionary_common.TimeRange updated_at = 25;
 * @return {?proto.fcp.dictionary.v1.dictionary_common.TimeRange}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.getUpdatedAt = function() {
  return /** @type{?proto.fcp.dictionary.v1.dictionary_common.TimeRange} */ (
    jspb.Message.getWrapperField(this, v1_dictionary_common_dictionary_common_pb.TimeRange, 25));
};


/**
 * @param {?proto.fcp.dictionary.v1.dictionary_common.TimeRange|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.setUpdatedAt = function(value) {
  return jspb.Message.setWrapperField(this, 25, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.clearUpdatedAt = function() {
  return this.setUpdatedAt(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.hasUpdatedAt = function() {
  return jspb.Message.getField(this, 25) != null;
};


/**
 * optional google.protobuf.StringValue updated_by = 26;
 * @return {?proto.google.protobuf.StringValue}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.getUpdatedBy = function() {
  return /** @type{?proto.google.protobuf.StringValue} */ (
    jspb.Message.getWrapperField(this, google_protobuf_wrappers_pb.StringValue, 26));
};


/**
 * @param {?proto.google.protobuf.StringValue|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.setUpdatedBy = function(value) {
  return jspb.Message.setWrapperField(this, 26, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.clearUpdatedBy = function() {
  return this.setUpdatedBy(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.prototype.hasUpdatedBy = function() {
  return jspb.Message.getField(this, 26) != null;
};





if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest.toObject = function(includeInstance, msg) {
  var f, obj = {
    id: jspb.Message.getFieldWithDefault(msg, 1, 0)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest}
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest;
  return proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest}
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {number} */ (reader.readInt64());
      msg.setId(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getId();
  if (f !== 0) {
    writer.writeInt64(
      1,
      f
    );
  }
};


/**
 * optional int64 id = 1;
 * @return {number}
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest.prototype.getId = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 1, 0));
};


/**
 * @param {number} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageRequest.prototype.setId = function(value) {
  return jspb.Message.setProto3IntField(this, 1, value);
};





if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse.prototype.toObject = function(opt_includeInstance) {
  return proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse.toObject = function(includeInstance, msg) {
  var f, obj = {
    item: (f = msg.getItem()) && proto.fcp.dictionary.v1.dictionary_md.ProductPackage.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse}
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse;
  return proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse}
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new proto.fcp.dictionary.v1.dictionary_md.ProductPackage;
      reader.readMessage(value,proto.fcp.dictionary.v1.dictionary_md.ProductPackage.deserializeBinaryFromReader);
      msg.setItem(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getItem();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      proto.fcp.dictionary.v1.dictionary_md.ProductPackage.serializeBinaryToWriter
    );
  }
};


/**
 * optional ProductPackage item = 1;
 * @return {?proto.fcp.dictionary.v1.dictionary_md.ProductPackage}
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse.prototype.getItem = function() {
  return /** @type{?proto.fcp.dictionary.v1.dictionary_md.ProductPackage} */ (
    jspb.Message.getWrapperField(this, proto.fcp.dictionary.v1.dictionary_md.ProductPackage, 1));
};


/**
 * @param {?proto.fcp.dictionary.v1.dictionary_md.ProductPackage|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse.prototype.setItem = function(value) {
  return jspb.Message.setWrapperField(this, 1, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse.prototype.clearItem = function() {
  return this.setItem(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.GetProductPackageResponse.prototype.hasItem = function() {
  return jspb.Message.getField(this, 1) != null;
};



/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.repeatedFields_ = [2];



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.toObject = function(includeInstance, msg) {
  var f, obj = {
    filter: (f = msg.getFilter()) && proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.toObject(includeInstance, f),
    sortingList: jspb.Message.toObjectList(msg.getSortingList(),
    v1_dictionary_common_dictionary_common_pb.Sorting.toObject, includeInstance),
    pagination: (f = msg.getPagination()) && v1_dictionary_common_dictionary_common_pb.PaginationRequest.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest;
  return proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter;
      reader.readMessage(value,proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.deserializeBinaryFromReader);
      msg.setFilter(value);
      break;
    case 2:
      var value = new v1_dictionary_common_dictionary_common_pb.Sorting;
      reader.readMessage(value,v1_dictionary_common_dictionary_common_pb.Sorting.deserializeBinaryFromReader);
      msg.addSorting(value);
      break;
    case 3:
      var value = new v1_dictionary_common_dictionary_common_pb.PaginationRequest;
      reader.readMessage(value,v1_dictionary_common_dictionary_common_pb.PaginationRequest.deserializeBinaryFromReader);
      msg.setPagination(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getFilter();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter.serializeBinaryToWriter
    );
  }
  f = message.getSortingList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      2,
      f,
      v1_dictionary_common_dictionary_common_pb.Sorting.serializeBinaryToWriter
    );
  }
  f = message.getPagination();
  if (f != null) {
    writer.writeMessage(
      3,
      f,
      v1_dictionary_common_dictionary_common_pb.PaginationRequest.serializeBinaryToWriter
    );
  }
};


/**
 * optional ProductPackageFilter filter = 1;
 * @return {?proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.prototype.getFilter = function() {
  return /** @type{?proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter} */ (
    jspb.Message.getWrapperField(this, proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter, 1));
};


/**
 * @param {?proto.fcp.dictionary.v1.dictionary_md.ProductPackageFilter|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.prototype.setFilter = function(value) {
  return jspb.Message.setWrapperField(this, 1, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.prototype.clearFilter = function() {
  return this.setFilter(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.prototype.hasFilter = function() {
  return jspb.Message.getField(this, 1) != null;
};


/**
 * repeated fcp.dictionary.v1.dictionary_common.Sorting sorting = 2;
 * @return {!Array<!proto.fcp.dictionary.v1.dictionary_common.Sorting>}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.prototype.getSortingList = function() {
  return /** @type{!Array<!proto.fcp.dictionary.v1.dictionary_common.Sorting>} */ (
    jspb.Message.getRepeatedWrapperField(this, v1_dictionary_common_dictionary_common_pb.Sorting, 2));
};


/**
 * @param {!Array<!proto.fcp.dictionary.v1.dictionary_common.Sorting>} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.prototype.setSortingList = function(value) {
  return jspb.Message.setRepeatedWrapperField(this, 2, value);
};


/**
 * @param {!proto.fcp.dictionary.v1.dictionary_common.Sorting=} opt_value
 * @param {number=} opt_index
 * @return {!proto.fcp.dictionary.v1.dictionary_common.Sorting}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.prototype.addSorting = function(opt_value, opt_index) {
  return jspb.Message.addToRepeatedWrapperField(this, 2, opt_value, proto.fcp.dictionary.v1.dictionary_common.Sorting, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.prototype.clearSortingList = function() {
  return this.setSortingList([]);
};


/**
 * optional fcp.dictionary.v1.dictionary_common.PaginationRequest pagination = 3;
 * @return {?proto.fcp.dictionary.v1.dictionary_common.PaginationRequest}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.prototype.getPagination = function() {
  return /** @type{?proto.fcp.dictionary.v1.dictionary_common.PaginationRequest} */ (
    jspb.Message.getWrapperField(this, v1_dictionary_common_dictionary_common_pb.PaginationRequest, 3));
};


/**
 * @param {?proto.fcp.dictionary.v1.dictionary_common.PaginationRequest|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.prototype.setPagination = function(value) {
  return jspb.Message.setWrapperField(this, 3, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.prototype.clearPagination = function() {
  return this.setPagination(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageRequest.prototype.hasPagination = function() {
  return jspb.Message.getField(this, 3) != null;
};



/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.repeatedFields_ = [1];



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.prototype.toObject = function(opt_includeInstance) {
  return proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.toObject = function(includeInstance, msg) {
  var f, obj = {
    itemsList: jspb.Message.toObjectList(msg.getItemsList(),
    proto.fcp.dictionary.v1.dictionary_md.ProductPackage.toObject, includeInstance),
    pagination: (f = msg.getPagination()) && v1_dictionary_common_dictionary_common_pb.PaginationResponse.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse;
  return proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new proto.fcp.dictionary.v1.dictionary_md.ProductPackage;
      reader.readMessage(value,proto.fcp.dictionary.v1.dictionary_md.ProductPackage.deserializeBinaryFromReader);
      msg.addItems(value);
      break;
    case 2:
      var value = new v1_dictionary_common_dictionary_common_pb.PaginationResponse;
      reader.readMessage(value,v1_dictionary_common_dictionary_common_pb.PaginationResponse.deserializeBinaryFromReader);
      msg.setPagination(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getItemsList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      1,
      f,
      proto.fcp.dictionary.v1.dictionary_md.ProductPackage.serializeBinaryToWriter
    );
  }
  f = message.getPagination();
  if (f != null) {
    writer.writeMessage(
      2,
      f,
      v1_dictionary_common_dictionary_common_pb.PaginationResponse.serializeBinaryToWriter
    );
  }
};


/**
 * repeated ProductPackage items = 1;
 * @return {!Array<!proto.fcp.dictionary.v1.dictionary_md.ProductPackage>}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.prototype.getItemsList = function() {
  return /** @type{!Array<!proto.fcp.dictionary.v1.dictionary_md.ProductPackage>} */ (
    jspb.Message.getRepeatedWrapperField(this, proto.fcp.dictionary.v1.dictionary_md.ProductPackage, 1));
};


/**
 * @param {!Array<!proto.fcp.dictionary.v1.dictionary_md.ProductPackage>} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.prototype.setItemsList = function(value) {
  return jspb.Message.setRepeatedWrapperField(this, 1, value);
};


/**
 * @param {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage=} opt_value
 * @param {number=} opt_index
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ProductPackage}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.prototype.addItems = function(opt_value, opt_index) {
  return jspb.Message.addToRepeatedWrapperField(this, 1, opt_value, proto.fcp.dictionary.v1.dictionary_md.ProductPackage, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.prototype.clearItemsList = function() {
  return this.setItemsList([]);
};


/**
 * optional fcp.dictionary.v1.dictionary_common.PaginationResponse pagination = 2;
 * @return {?proto.fcp.dictionary.v1.dictionary_common.PaginationResponse}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.prototype.getPagination = function() {
  return /** @type{?proto.fcp.dictionary.v1.dictionary_common.PaginationResponse} */ (
    jspb.Message.getWrapperField(this, v1_dictionary_common_dictionary_common_pb.PaginationResponse, 2));
};


/**
 * @param {?proto.fcp.dictionary.v1.dictionary_common.PaginationResponse|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.prototype.setPagination = function(value) {
  return jspb.Message.setWrapperField(this, 2, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.prototype.clearPagination = function() {
  return this.setPagination(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.ListProductPackageResponse.prototype.hasPagination = function() {
  return jspb.Message.getField(this, 2) != null;
};





if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest.toObject = function(includeInstance, msg) {
  var f, obj = {
    item: (f = msg.getItem()) && proto.fcp.dictionary.v1.dictionary_md.ProductPackage.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest}
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest;
  return proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest}
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new proto.fcp.dictionary.v1.dictionary_md.ProductPackage;
      reader.readMessage(value,proto.fcp.dictionary.v1.dictionary_md.ProductPackage.deserializeBinaryFromReader);
      msg.setItem(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getItem();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      proto.fcp.dictionary.v1.dictionary_md.ProductPackage.serializeBinaryToWriter
    );
  }
};


/**
 * optional ProductPackage item = 1;
 * @return {?proto.fcp.dictionary.v1.dictionary_md.ProductPackage}
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest.prototype.getItem = function() {
  return /** @type{?proto.fcp.dictionary.v1.dictionary_md.ProductPackage} */ (
    jspb.Message.getWrapperField(this, proto.fcp.dictionary.v1.dictionary_md.ProductPackage, 1));
};


/**
 * @param {?proto.fcp.dictionary.v1.dictionary_md.ProductPackage|undefined} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest} returns this
*/
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest.prototype.setItem = function(value) {
  return jspb.Message.setWrapperField(this, 1, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest.prototype.clearItem = function() {
  return this.setItem(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageRequest.prototype.hasItem = function() {
  return jspb.Message.getField(this, 1) != null;
};





if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse.prototype.toObject = function(opt_includeInstance) {
  return proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse.toObject = function(includeInstance, msg) {
  var f, obj = {
    id: jspb.Message.getFieldWithDefault(msg, 1, 0)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse}
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse;
  return proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse}
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {number} */ (reader.readInt64());
      msg.setId(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getId();
  if (f !== 0) {
    writer.writeInt64(
      1,
      f
    );
  }
};


/**
 * optional int64 id = 1;
 * @return {number}
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse.prototype.getId = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 1, 0));
};


/**
 * @param {number} value
 * @return {!proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse} returns this
 */
proto.fcp.dictionary.v1.dictionary_md.SaveProductPackageResponse.prototype.setId = function(value) {
  return jspb.Message.setProto3IntField(this, 1, value);
};


goog.object.extend(exports, proto.fcp.dictionary.v1.dictionary_md);
